package com.hello;

import com.hello.framework.AbstractPlayer;
import com.hello.framework.AbstractRole;
import com.hello.framework.Game;
import com.hello.framework.MetagameModel;
import com.hello.metagame.TFAFMetagameModel;
import com.hello.role.*;

/**
 * respect cndl and Romanesco
 */
public class GreetingPlayer extends AbstractPlayer {

    @Override
    public String getName() {
        return "hello_wolf";
    }

    @Override
    protected MetagameModel createMetagameModel() {
        return new TFAFMetagameModel();
    }

    @Override
    protected AbstractRole selectRole(Game game) {
        if (game.getVillageSize() == 5) {
            switch (game.getSelf().role) {
                case WEREWOLF:
                    return new WerewolfRole5ver(game);
                case POSSESSED:
                    return new PossessedRole5ver(game);
                case SEER:
                    return new SeerRole5ver(game);
                case VILLAGER:
                    return new VillagerRole5ver(game);
            }
        } else {
            switch (game.getSelf().role) {
                case WEREWOLF:
                    return new WerewolfRole(game);
                case BODYGUARD:
                    return new BodyguardRole(game);
                case MEDIUM:
                    return new MediumRole(game);
                case POSSESSED:
                    return new PossessedRole(game);
                case SEER:
                    return new SeerRole(game);
                case VILLAGER:
                    return new VillagerRole(game);
            }
        }
        return null;
    }
}
