package com.hello.role;

import com.hello.framework.Day;
import com.hello.framework.Game;
import com.hello.talk.*;
import com.hello.target.*;
import org.aiwolf.common.data.Role;

import java.security.SecureRandom;

public class PossessedRole5ver extends TFAFBaseRole {

	public PossessedRole5ver(Game game) {
		super(game);

		int kibun = new SecureRandom().nextInt(3);

		if (kibun == 0) {
			// 最初のターン、占いCO
			talkTactics.add(new TalkCO(Role.SEER), 10000, Day.on(1));
			// 占い師CO以外に黒出し
			talkTactics.add(new TalkDivineBlackAttacktoNoSeer(), 10000, Day.on(1));
			//黒判定を宣言したエージェントへVote宣言をする。
			talkTactics.add(new TalkVoteForFakeBlack(), 9000, Day.on(1));

			// 最終日狼CO
			talkTactics.add(new TalkSlideCO(Role.WEREWOLF), 10000, Day.on(2));

			// 狼COしていないものに投票
			voteTactics.add(new VoteLast3PPTactic5ver());
			revoteTactics.add(new VoteLast3PPTactic5ver());

			//自分の黒出しに投票
			voteTactics.add(new VoteWByPo5ver(), 10000);
			revoteTactics.add(new VoteWByPo5ver(), 10000);

			// 狼ランキングトップを避けて投票。
			voteTactics.add(new VoteWithoutWolf(), 9000);
			revoteTactics.add(new VoteWithoutWolf(), 9000);
		}else if (kibun == 1) {
			// 最初のターン、占いCO
			talkTactics.add(new TalkCO(Role.SEER), 10000, Day.on(1));
			// 占い師CO以外に白出し
			talkTactics.add(new TalkDivineWhiteAttaktoNoSeer(), 10000, Day.on(1));
			//最大得票数に乗っかる
			voteTactics.add(new VoteToLive5Wolf());
			//最大得票数に乗っかる
			revoteTactics.add(new RevoteToLive5Wolf());
			// 最終日狼CO
			talkTactics.add(new TalkSlideCO(Role.WEREWOLF), 10000, Day.on(2));

			// 狼COしていないものに投票
			voteTactics.add(new VoteLast3PPTactic5ver());
			revoteTactics.add(new VoteLast3PPTactic5ver());

			// 狼ランキングトップを避けて投票。
			voteTactics.add(new VoteWithoutWolf(), 9000);
			revoteTactics.add(new VoteWithoutWolf(), 9000);
	 	} else {
			/*
			// 最初のターン、占いCO
			talkTactics.add(new TalkCO(Role.SEER), 10000, Day.on(1));
			// COの次ターン、対抗占いに黒。対抗COがない場合は狼ランキング最下位に黒。
			talkTactics.add(new TalkDivineBlackAttacktoSeer(), 10000, Day.on(1));
			//黒判定を宣言したエージェントへVote宣言をする。
			talkTactics.add(new TalkVoteForFakeBlack(), 9000, Day.on(1));

			// 最終日狼CO
			talkTactics.add(new TalkSlideCO(Role.WEREWOLF), 10000, Day.on(2));

			// 狼COしていないものに投票
			voteTactics.add(new VoteLast3PPTactic5ver());
			revoteTactics.add(new VoteLast3PPTactic5ver());

			//自分の黒出しに投票
			voteTactics.add(new VoteWByPo5ver(), 10000);
			revoteTactics.add(new VoteWByPo5ver(), 10000);

			// 狼ランキングトップを避けて投票。
			voteTactics.add(new VoteWithoutWolf(), 9000);
			revoteTactics.add(new VoteWithoutWolf(), 9000);
			 */
			// 最初のターン、狼CO
			talkTactics.add(new TalkCO(Role.WEREWOLF), 10000, Day.on(1));
			// 最終日狼CO
			talkTactics.add(new TalkSlideCO(Role.WEREWOLF), 10000, Day.on(2));

			talkTactics.add(new TalkVote5WolfDay1(), 9000, Day.on(1), Repeat.MULTI);
			talkTactics.add(new TalkVote5WolfDay2(), 9000, Day.on(1), Repeat.MULTI);

			voteTactics.add(new VoteWithoutWolf(), 9000);
			revoteTactics.add(new VoteWithoutWolf(), 9000);

		}
	}

}
