package com.hello.role;

import com.hello.framework.Day;
import com.hello.framework.Game;
import com.hello.framework.GameAgent;
import com.hello.talk.TalkCO;
import com.hello.talk.TalkDivineWithEvilScore5ver;
import com.hello.talk.TalkSlideCO;
import com.hello.talk.TalkVoteWolfbySeer5ver;
import com.hello.target.DivineBasic;
import com.hello.target.DivineByAI;
import com.hello.target.VoteWolfbySeer;
import org.aiwolf.common.data.Role;

import java.util.HashSet;
import java.util.Set;

public class SeerRole5ver extends TFAFBaseRole {

    private Set<GameAgent> divined = new HashSet<>();

    public SeerRole5ver(Game game) {
        super(game);

        //初日CO
        talkTactics.add(new TalkCO(Role.SEER), 10000, Day.on(1));
        //白判定時、自分のモデルを信じて黒として伝える。
        talkTactics.add(new TalkDivineWithEvilScore5ver(), 9000, Day.any());
        talkTactics.add(new TalkVoteWolfbySeer5ver(), 8000, Day.any());

        //0日目は勝率の高いAIを占う
        divineTactics.add(new DivineByAI(divined), Day.on(0));
        //1日目以降はEvilScoreの高いエージェントを占う
        divineTactics.add(new DivineBasic(divined), Day.after(1));

        // 自分の黒判定に投票。白を除くもっとも狼らしいエージェントに投票
        voteTactics.add(new VoteWolfbySeer());
        revoteTactics.add(new VoteWolfbySeer());

        //最終日狂人CO
        talkTactics.add(new TalkSlideCO(Role.POSSESSED), 10000, Day.on(2));


    }

}
