package com.hello.role;

import com.hello.framework.Day;
import com.hello.framework.Game;
import com.hello.talk.TalkCO5WolfLast3PP;
import com.hello.talk.TalkVoteByAI;
import com.hello.talk.TalkVoteReadAirLittle;
import com.hello.talk.TalkVoteWolf;
import com.hello.target.RevoteMajority;
import com.hello.target.VoteAsAnnouncedToLive;

public class VillagerRole extends TFAFBaseRole {

    public VillagerRole(Game game) {
        super(game);
        //会話戦略
        //初日最初は勝率の高いAIに投票宣言
        talkTactics.add(new TalkVoteByAI(), 1000, Day.on(1), Repeat.ONCE);
        //二日目以降最初は最も怪しいAgentに投票宣言
        talkTactics.add(new TalkVoteWolf(), 1000, Day.after(2), Repeat.ONCE);
        //以降は場の空気を読んでみる
        talkTactics.add(new TalkVoteReadAirLittle(), 100, Day.any(), Repeat.MULTI);
        //残り人数が3人になったら、裏切り者CO
        talkTactics.add(new TalkCO5WolfLast3PP(), 15000, Day.any());
        //投票戦略
        //投票宣言した相手に対して投票する
        voteTactics.add(new VoteAsAnnouncedToLive());
        //再投票では、マジョリティに対して投票する
        revoteTactics.add(new RevoteMajority());
    }

}
