package com.hello.talk;

import com.hello.framework.Game;
import com.hello.framework.GameAgent;
import com.hello.util.Utils;
import com.hello.model.TFAFGameModel;
import org.aiwolf.client.lib.ContentBuilder;
import org.aiwolf.client.lib.DivinedResultContentBuilder;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;

import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * EvilScore最下位に黒発言をする
 */
public class TalkDivineBlackAttacktoNoSeer extends TFAFTalkTactic {

	@Override
	public ContentBuilder talkImpl(int turn, int skip, int utter, TFAFGameModel model, Game game) {
		if (game.getSelf().hasCO()) {
			/* SEER としてCOしている者たち */
			Set<GameAgent> seerCOs = game.getAliveOthers().stream().filter(ag -> ag.coRole == Role.SEER)
					.collect(Collectors.toSet());

			List<GameAgent> list = game.getAliveOthers().stream().filter(ag -> !seerCOs.contains(ag))
					.collect(Collectors.toList());

			Utils.sortByScore(list, model.getEvilScore(), false);
			GameAgent wolfCand = list.get(list.size() - 1);
			return new DivinedResultContentBuilder(wolfCand.agent, Species.WEREWOLF);
		}
		return null;
	}
}
