package com.hello.target;

import com.hello.framework.EventType;
import com.hello.framework.Game;
import com.hello.framework.GameAgent;
import com.hello.framework.GameEvent;
import com.hello.util.Utils;
import com.hello.model.TFAFGameModel;
import org.aiwolf.common.data.Species;

import java.util.List;

public class VoteWolfbySeer extends TFAFTargetTactic {

    @Override
    public GameAgent targetImpl(TFAFGameModel model, Game game) {
        if (divineTarget != null && result == Species.WEREWOLF) {
            return divineTarget;
        } else {
            // 白を除く、最も狼らしいAgentに投票宣言
            List<GameAgent> list = game.getAliveOthers();
            if (divineTarget != null) {
                list.remove(divineTarget);
            }
            Utils.sortByScore(list, model.getEvilScore(), false);
            GameAgent wolfCand = list.get(0);
            return wolfCand;
        }
    }

    private GameAgent divineTarget;
    private Species result;

    @Override
    public void handleEvent(Game g, GameEvent e) {
        if (e.type == EventType.DIVINE) {
            divineTarget = e.target;
            result = e.species;
        }
    }
}
